#include "example.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _di_example_setting_load_
  void example_setting_load(const f_console_arguments_t arguments, example_main_t * const main) {

    if (!main) return;

    main->setting.state.step_small = example_allocation_console_d;

    f_console_parameter_process(arguments, &main->program.parameters, &main->setting.state, 0);

    main->setting.state.step_small = example_allocation_small_d;

    if (F_status_is_error(main->setting.state.status)) {
      example_print_error(&main->program.error, macro_example_f(f_console_parameter_process));

      return;
    }

    main->setting.state.status = fll_program_parameter_process_context_standard(F_true, &main->program);

    if (F_status_is_error(main->setting.state.status)) {
      example_print_error(&main->program.error, macro_example_f(fll_program_parameter_process_context_standard));

      return;
    }

    main->setting.state.status = fll_program_parameter_process_verbosity_standard(F_true, &main->program);

    if (F_status_is_error(main->setting.state.status)) {
      example_print_error(&main->program.error, macro_example_f(fll_program_parameter_process_verbosity_standard));

      return;
    }

    if (main->program.parameters.array[f_console_standard_parameter_help_e].result & f_console_result_found_e) {
      main->setting.flag |= example_main_flag_help_d;

      return;
    }

    if (main->program.parameters.array[f_console_standard_parameter_version_e].result & f_console_result_found_e) {
      main->setting.flag |= example_main_flag_version_d;

      return;
    }

    if (main->program.parameters.array[f_console_standard_parameter_copyright_e].result & f_console_result_found_e) {
      main->setting.flag |= example_main_flag_copyright_d;

      return;
    }

    if (main->program.pipe & fll_program_data_pipe_input_e) {
      main->setting.flag |= example_main_flag_pipe_d;
    }
    else {
      main->setting.flag &= ~example_main_flag_pipe_d;
    }
  }
#endif // _di_example_setting_load_

#ifdef __cplusplus
} // extern "C"
#endif
