#include "example.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _di_example_main_
  void example_main(example_main_t * const main) {

    if (!main || F_status_is_error(main->setting.state.status)) return;

    main->setting.state.status = F_okay;

    if (main->setting.flag & example_main_flag_version_copyright_help_d) {
      if (main->setting.flag & example_main_flag_help_d) {
        example_print_message_help(&main->program.message);
      }
      else if (main->setting.flag & example_main_flag_version_d) {
        fll_program_print_version(&main->program.message, example_program_version_s);
      }
      else if (main->setting.flag & example_main_flag_copyright_d) {
        fll_program_print_copyright(&main->program.message, fll_program_copyright_year_author_s);
      }

      return;
    }

    if (main->setting.state.status == F_status_set_error(F_interrupt)) {
      fll_program_print_signal_received(&main->program.warning, main->program.signal_received);
    }
  }
#endif // _di_example_main_

#ifdef __cplusplus
} // extern "C"
#endif
